
//Source for a igs_reg test program capable to change all igs vga registers
// in real time...
//Woody, April 1998

#define REGE4A0 (0xE4A0 - 0xE430)/4
#define REGE4A4 (0xE4A4 - 0xE430)/4

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/errno.h>
#include <fcntl.h>
#include "igsvga.h"



main(int argc, char *argv[])
{
unsigned int regno, val, i;
struct reg_ops rops;
int igsvga_fd=-1;
unsigned supported;
int source;



unsigned long e4a4, e4a0;

    igsvga_fd=open("/dev/igsvga",O_RDWR);
    if(igsvga_fd<0){
      perror("igs_reg: igsvga not found!");
      exit(-1);
    }

    for(i = 30; i < 40; i++)
    	printf("\033[1;%dmX\tX\tX\tX\tX\tX\n", i);

    for(i = 30; i < 40; i++)
    	printf("\033[0;%dmX\tX\tX\tX\tX\tX\n", i);
	

    if(argc == 3)
    {
    	sscanf(argv[1], "%i", &e4a4);
	sscanf(argv[2], "%i", &e4a0);
	rops.reg_t = TV_CMD;
	rops.reg = REGE4A4;
	rops.val = e4a4;
	ioctl(igsvga_fd,IGSVGA_WRITE_SPECIFIC,(unsigned long)&rops);

	rops.reg_t = TV_CMD;
	rops.reg = REGE4A0;
	rops.val = e4a0;
	ioctl(igsvga_fd,IGSVGA_WRITE_SPECIFIC,(unsigned long)&rops);
    }
    else
    {
	    for(e4a4 = 0x46ea; e4a4 < 0x4900; e4a4++)
	    {
    		for(e4a0 = 0; e4a0 < 0x10000; e4a0++)
		{
			rops.reg_t = TV_CMD;
			rops.reg = REGE4A4;
			rops.val = e4a4;
			ioctl(igsvga_fd,IGSVGA_WRITE_SPECIFIC,(unsigned long)&rops);

			rops.reg_t = TV_CMD;
			rops.reg = REGE4A0;
			rops.val = e4a0;
			ioctl(igsvga_fd,IGSVGA_WRITE_SPECIFIC,(unsigned long)&rops);
		}
		if((e4a4 % 0x100) == 0)
		{
			printf("\033[1;34m%x\t", e4a4);
			fflush(stdout);
		}
	    }
    }

    close(igsvga_fd);

}
